#include "stdio.h"
#include "assert.h"
#include <fstream>
#include <iostream>
#include <string>

using namespace std;

const int maxn = 1024;

int r1, c1, r2, c2;
string s[maxn];
int n, m;
fstream fin, fout, fans;

void botva(char *msg)
{
   cout << msg;
   fin.close(); fout.close(); fans.close();
}

int chk_out()
{
   r1--; c1--; r2--; c2--;
   if (r1 < 0 || r1 >= n || c1 < 0 || c1 >= m) {botva("illegal numbers"); return 1;}
   if (r2 < 0 || r2 >= n || c2 < 0 || c2 >= m) {botva("illegal numbers"); return 1;}
   return 0;
}

int chk_jury()
{
   r1--; c1--; r2--; c2--;
   if (r1 < 0 || r1 >= n || c1 < 0 || c1 >= m) {botva("jury: illegal numbers"); return 3;}
   if (r2 < 0 || r2 >= n || c2 < 0 || c2 >= m) {botva("jury: illegal numbers"); return 3;}
   return 0;
}

int calc1(int i, int j)
{
   int en = 0;
   for (int dx = -1; dx <= 1; dx++)
      for (int dy = -1; dy <= 1; dy++)
         if (abs(dx) + abs(dy) == 1) {
            int x = i + dx, y = j + dy;
            if (x >= 0 && x < n && y >= 0 && y < m) {
               if (s[x][y] == s[i][j]) en++; else en--;
            }
         }
   return en;
}

int calc() 
{
   int energy = calc1(r1, c1) + calc1(r2, c2);
   if (abs(r2-r1) + abs(c2-c1) == 1) energy += (s[r1][c1] == s[r2][c2]) ? -2 : 2;
   return energy;
}

int main(int argc, char* argv[])
{
   ifstream fin; ifstream fout; ifstream fans;
   fin.open(argv[1],ios::in); fout.open(argv[2],ios::in); fans.open(argv[3],ios::in);

   int i;
   fin >> n >> m;
   for (i = 0; i < n; i++) fin >> s[i];

   fout >> r1 >> c1 >> r2 >> c2;
   if (1 > r1 || r1 > n || 1 > c1 || c1 > m) {botva("illegal point"); return 1;}
   if (1 > r2 || r2 > n || 1 > c2 || c2 > m) {botva("illegal point"); return 1;}
   if (i = chk_out()) return i;
   if (r1 == r2 && c1 == c2) {botva("same point"); return 1;}
   int best_out = calc();

   fans >> r1 >> c1 >> r2 >> c2;
   if (1 > r1 || r1 > n || 1 > c1 || c1 > m) {botva("jury: illegal point"); return 3;}
   if (1 > r2 || r2 > n || 1 > c2 || c2 > m) {botva("jury: illegal point"); return 3;}
   if (i = chk_jury()) return i;
   if (r1 == r2 && c1 == c2) {botva("jury: same point"); return 3;}
   int best_jury = calc();

   if (!fout) {botva(""); return 2;}
   if (!fans) {botva("jury bug: botva in output"); return 3;}
   if (best_out > best_jury) {cout << "contestant is better (" <<  best_out << ">" << best_jury; botva(""); return 3;}
   if (best_out < best_jury) {cout << "jury is better (" <<  best_out << "<" << best_jury; botva(""); return 1;}

   botva("Ok");
   return 0;
}
